Shortcut integration: operations for AI agents
Shortcut connects to Type.com as an integration. This page lists the 143 operations documented for Claude and Codex in Type.com: 71 read, 43 write, 29 destructive.
About Shortcut
Shortcut REST API v3 reference operations, subject to Type setup and account permissions.
Categories: Productivity & Project Management
How to connect Shortcut to Type.com
- Connect
- Configure provider-specific API target and authentication setup.
- Access
- Organization connection: one shared account for the workspace.
To add the connection, follow the steps in Space connections.
Documented operations
143 operations. Your connection's permissions determine which operations are available. API references describe the vendor surface; they do not expand your connection's credentials or access.
143 operations listed.
Categories
- Read
List Categories
List Categories returns a list of all Categories and their attributes.
GET /api/v3/categories - Read
Get Category
Get Category returns information about the selected Category.
GET /api/v3/categories/{category-public-id} - Read
List Category Milestones
List Category Milestones returns a list of all Milestones with the Category.
GET /api/v3/categories/{category-public-id}/milestones - Read
List Category Objectives
Returns a list of all Objectives with the Category.
GET /api/v3/categories/{category-public-id}/objectives - Write
Create Category
Create Category allows you to create a new Category in Shortcut.
POST /api/v3/categories - Write
Update Category
Update Category allows you to replace a Category name with another name. If you try to name a Category something that already exists, you will receive a 422 response.
PUT /api/v3/categories/{category-public-id} - Destructive
Delete Category
Delete Category can be used to delete any Category.
DELETE /api/v3/categories/{category-public-id}
Custom fields
- Read
List Custom Fields
GET /api/v3/custom-fields
GET /api/v3/custom-fields - Read
Get Custom Field
GET /api/v3/custom-fields/{custom-field-public-id}
GET /api/v3/custom-fields/{custom-field-public-id} - Destructive
Update Custom Field
Update Custom Field can be used to update the definition of a Custom Field. The order of items in the 'values' collection is interpreted to be their ascending sort order.To delete an existing enum value, simply omit it from the 'values' collection. New enum values may be created inline by including an object in the 'values' collection having a 'value' entry with no 'id' (eg. {'value': 'myNewValue', 'color_key': 'green'}).
PUT /api/v3/custom-fields/{custom-field-public-id} - Destructive
Delete Custom Field
DELETE /api/v3/custom-fields/{custom-field-public-id}
DELETE /api/v3/custom-fields/{custom-field-public-id}
Documents
- Read
List Docs
List Docs returns a list of Doc that the current user can read.
GET /api/v3/documents - Read
Get Doc
Get a Doc by its public ID with content. Use content_format=html query parameter to include HTML content.
GET /api/v3/documents/{doc-public-id} - Read
List Document Epics
Get a list of all Epics related to this Document.
GET /api/v3/documents/{doc-public-id}/epics - Write
Create Doc
Creates a new Doc. Supports markdown or HTML input via content_format parameter. WARNING: if content_format is not supplied, `content` input defaults to html.
POST /api/v3/documents - Write
Link Document to Epic
Create a relationship between a Document and an Epic.
PUT /api/v3/documents/{doc-public-id}/epics/{epic-public-id} - Destructive
Update Doc
Updates an existing Doc's title and/or content. Supports markdown or HTML input via content_format parameter. WARNING: if content_format is not supplied, `content` input defaults to html. When a document is updated: (1) For Tiptap-migrated docs, SSE events notify connected Tiptap clients to refresh. (2) For non-migrated docs, CKEditor cache is flushed and SSE events notify connected CKEditor users.
PUT /api/v3/documents/{doc-public-id} - Destructive
Delete Doc
Permanently deletes a Doc and its associated data. Requires admin access to the doc. When a document is deleted, connected clients will be notified via SSE events.
DELETE /api/v3/documents/{doc-public-id} - Destructive
Unlink Document from Epic
Remove a relationship between a Document and an Epic.
DELETE /api/v3/documents/{doc-public-id}/epics/{epic-public-id}
Entity templates
- Read
List Entity Templates
List all the entity templates for the Workspace.
GET /api/v3/entity-templates - Read
Get Entity Template
Get Entity Template returns information about a given entity template.
GET /api/v3/entity-templates/{entity-template-public-id} - Write
Create Entity Template
Create a new entity template for the Workspace.
POST /api/v3/entity-templates - Write
Enable Story Templates
Enables the Story Template feature for the Workspace.
PUT /api/v3/entity-templates/enable - Write
Update Entity Template
Update an entity template's name or its contents.
PUT /api/v3/entity-templates/{entity-template-public-id} - Destructive
Disable Story Templates
Disables the Story Template feature for the Workspace.
PUT /api/v3/entity-templates/disable - Destructive
Delete Entity Template
DELETE /api/v3/entity-templates/{entity-template-public-id}
DELETE /api/v3/entity-templates/{entity-template-public-id}
Epic workflow
- Read
Get Epic Workflow
Returns the Epic Workflow for the Workspace.
GET /api/v3/epic-workflow
Epics
- Read
List Epics
List Epics returns a list of all Epics and their attributes.
GET /api/v3/epics - Read
List Epics Paginated
List Epics with pagination returns a paginated list of Epics and their attributes.
GET /api/v3/epics/paginated - Read
Get Epic
Get Epic returns information about the selected Epic.
GET /api/v3/epics/{epic-public-id} - Read
List Epic Comments
Get a list of all Comments on an Epic.
GET /api/v3/epics/{epic-public-id}/comments - Read
Get Epic Comment
This endpoint returns information about the selected Epic Comment.
GET /api/v3/epics/{epic-public-id}/comments/{comment-public-id} - Read
List Epic Documents
Get a list of all Documents related to this Epic.
GET /api/v3/epics/{epic-public-id}/documents - Read
Get Epic Health
Get the current health for the specified Epic.
GET /api/v3/epics/{epic-public-id}/health - Read
List Epic Healths
List the history of health statuses for the specified Epic, most recent first.
GET /api/v3/epics/{epic-public-id}/health-history - Read
List Epic Stories
Get a list of all Stories in an Epic.
GET /api/v3/epics/{epic-public-id}/stories - Write
Create Epic
Create Epic allows you to create a new Epic in Shortcut.
POST /api/v3/epics - Write
Update Epic
Update Epic can be used to update numerous fields in the Epic. The only required parameter is Epic ID, which can be found in the Shortcut UI.
PUT /api/v3/epics/{epic-public-id} - Write
Create Epic Comment
This endpoint allows you to create a threaded Comment on an Epic.
POST /api/v3/epics/{epic-public-id}/comments - Write
Create Epic Comment Comment
This endpoint allows you to create a nested Comment reply to an existing Epic Comment.
POST /api/v3/epics/{epic-public-id}/comments/{comment-public-id} - Write
Update Epic Comment
This endpoint allows you to update a threaded Comment on an Epic.
PUT /api/v3/epics/{epic-public-id}/comments/{comment-public-id} - Write
Create Epic Health
Create a new health status for the specified Epic.
POST /api/v3/epics/{epic-public-id}/health - Destructive
Delete Epic
Delete Epic can be used to delete the Epic. The only required parameter is Epic ID.
DELETE /api/v3/epics/{epic-public-id} - Destructive
Delete Epic Comment
This endpoint allows you to delete a Comment from an Epic.
DELETE /api/v3/epics/{epic-public-id}/comments/{comment-public-id}
External link
- Read
Get External Link Stories
Get Stories which have a given External Link associated with them.
GET /api/v3/external-link/stories
Files
- Read
List Files
List Files returns a list of all UploadedFiles in the workspace.
GET /api/v3/files - Read
Get File
Get File returns information about the selected UploadedFile.
GET /api/v3/files/{file-public-id} - Write
Upload Files
Upload Files uploads one or many files and optionally associates them with a story. Use the multipart/form-data content-type to upload. Each `file` key should contain a separate file. Each UploadedFile's name comes from the Content-Disposition header "filename" directive for that field.
POST /api/v3/files - Write
Update File
Update File updates the properties of an UploadedFile (but not its content).
PUT /api/v3/files/{file-public-id} - Destructive
Delete File
Delete File deletes a previously uploaded file.
DELETE /api/v3/files/{file-public-id}
Groups
- Read
List Groups
A group in our API maps to a "Team" within the Shortcut Product. A Team is a collection of Users that can be associated to Stories, Epics, and Iterations within Shortcut.
GET /api/v3/groups - Read
Get Group
GET /api/v3/groups/{group-public-id}
GET /api/v3/groups/{group-public-id} - Read
List Group Stories
List the Stories assigned to the Group. (By default, limited to 1,000).
GET /api/v3/groups/{group-public-id}/stories - Write
Create Group
POST /api/v3/groups
POST /api/v3/groups - Write
Update Group
PUT /api/v3/groups/{group-public-id}
PUT /api/v3/groups/{group-public-id}
Health
- Write
Update Health
Update an existing health status by its ID.
PUT /api/v3/health/{health-public-id}
Integrations
- Read
Get Generic Integration
GET /api/v3/integrations/webhook/{integration-public-id}
GET /api/v3/integrations/webhook/{integration-public-id} - Write
Create Generic Integration
POST /api/v3/integrations/webhook
POST /api/v3/integrations/webhook - Destructive
Delete Generic Integration
DELETE /api/v3/integrations/webhook/{integration-public-id}
DELETE /api/v3/integrations/webhook/{integration-public-id}
Iterations
- Read
List Iterations
GET /api/v3/iterations
GET /api/v3/iterations - Read
Get Iteration
GET /api/v3/iterations/{iteration-public-id}
GET /api/v3/iterations/{iteration-public-id} - Read
List Iteration Stories
Get a list of all Stories in an Iteration.
GET /api/v3/iterations/{iteration-public-id}/stories - Write
Create Iteration
POST /api/v3/iterations
POST /api/v3/iterations - Write
Enable Iterations
Enables Iterations for the current workspace
PUT /api/v3/iterations/enable - Write
Update Iteration
PUT /api/v3/iterations/{iteration-public-id}
PUT /api/v3/iterations/{iteration-public-id} - Destructive
Disable Iterations
Disables Iterations for the current workspace
PUT /api/v3/iterations/disable - Destructive
Delete Iteration
DELETE /api/v3/iterations/{iteration-public-id}
DELETE /api/v3/iterations/{iteration-public-id}
Key results
- Read
Get Key Result
Get Key Result returns information about a chosen Key Result.
GET /api/v3/key-results/{key-result-public-id} - Write
Update Key Result
Update Key Result allows updating a Key Result's name or initial, observed, or target values.
PUT /api/v3/key-results/{key-result-public-id}
Labels
- Read
List Labels
List Labels returns a list of all Labels and their attributes.
GET /api/v3/labels - Read
Get Label
Get Label returns information about the selected Label.
GET /api/v3/labels/{label-public-id} - Read
List Label Epics
List all of the Epics with the Label.
GET /api/v3/labels/{label-public-id}/epics - Read
List Label Stories
List all of the Stories with the Label.
GET /api/v3/labels/{label-public-id}/stories - Write
Create Label
Create Label allows you to create a new Label in Shortcut.
POST /api/v3/labels - Write
Update Label
Update Label allows you to replace a Label name with another name. If you try to name a Label something that already exists, you will receive a 422 response.
PUT /api/v3/labels/{label-public-id} - Destructive
Delete Label
Delete Label can be used to delete any Label.
DELETE /api/v3/labels/{label-public-id}
Linked files
- Read
List Linked Files
List Linked Files returns a list of all Linked-Files and their attributes.
GET /api/v3/linked-files - Read
Get Linked File
Get File returns information about the selected Linked File.
GET /api/v3/linked-files/{linked-file-public-id} - Write
Create Linked File
Create Linked File allows you to create a new Linked File in Shortcut.
POST /api/v3/linked-files - Write
Update Linked File
Updated Linked File allows you to update properties of a previously attached Linked-File.
PUT /api/v3/linked-files/{linked-file-public-id} - Destructive
Delete Linked File
Delete Linked File can be used to delete any previously attached Linked-File.
DELETE /api/v3/linked-files/{linked-file-public-id}
Member
- Read
Get Current Member Info
Returns information about the authenticated member.
GET /api/v3/member
Members
- Read
List Members
Returns information about members of the Workspace.
GET /api/v3/members - Read
Get Member
Returns information about a Member.
GET /api/v3/members/{member-public-id}
API
- Read
List Milestones (deprecated)
(Deprecated: Use 'List Objectives') List Milestones returns a list of all Milestones and their attributes.
GET /api/v3/milestones - Read
Get Milestone (deprecated)
(Deprecated: Use 'Get Objective') Get Milestone returns information about a chosen Milestone.
GET /api/v3/milestones/{milestone-public-id} - Read
List Milestone Epics (deprecated)
(Deprecated: Use 'List Objective Epics') List all of the Epics within the Milestone.
GET /api/v3/milestones/{milestone-public-id}/epics - Write
Create Milestone (deprecated)
(Deprecated: Use 'Create Objective') Create Milestone allows you to create a new Milestone in Shortcut.
POST /api/v3/milestones - Write
Update Milestone (deprecated)
(Deprecated: Use 'Update Objective') Update Milestone can be used to update Milestone properties.
PUT /api/v3/milestones/{milestone-public-id} - Destructive
Delete Milestone (deprecated)
(Deprecated: Use 'Delete Objective') Delete Milestone can be used to delete any Milestone.
DELETE /api/v3/milestones/{milestone-public-id}
Objectives
- Read
List Objectives
List Objectives returns a list of all Objectives and their attributes.
GET /api/v3/objectives - Read
Get Objective
Get Objective returns information about a chosen Objective.
GET /api/v3/objectives/{objective-public-id} - Read
List Objective Epics
List all of the Epics within the Objective.
GET /api/v3/objectives/{objective-public-id}/epics - Read
Get Objective Health
Get the current health for the specified Objective.
GET /api/v3/objectives/{objective-public-id}/health - Read
List Objective Healths
List the history of health statuses for the specified Objective, most recent first.
GET /api/v3/objectives/{objective-public-id}/health-history - Write
Create Objective
Create Objective allows you to create a new Objective in Shortcut.
POST /api/v3/objectives - Write
Update Objective
Update Objective can be used to update Objective properties.
PUT /api/v3/objectives/{objective-public-id} - Write
Create Objective Health
Create a new health status for the specified Objective.
POST /api/v3/objectives/{objective-public-id}/health - Destructive
Delete Objective
Delete Objective can be used to delete any Objective.
DELETE /api/v3/objectives/{objective-public-id}
Projects
- Read
List Projects
List Projects returns a list of all Projects and their attributes.
GET /api/v3/projects - Read
Get Project
Get Project returns information about the selected Project.
GET /api/v3/projects/{project-public-id} - Read
List Stories
List Stories returns a list of all Stories in a selected Project and their attributes.
GET /api/v3/projects/{project-public-id}/stories - Write
Create Project
Create Project is used to create a new Shortcut Project.
POST /api/v3/projects - Write
Update Project
Update Project can be used to change properties of a Project.
PUT /api/v3/projects/{project-public-id} - Destructive
Delete Project
Delete Project can be used to delete a Project. Projects can only be deleted if all associated Stories are moved or deleted. In the case that the Project cannot be deleted, you will receive a 422 response.
DELETE /api/v3/projects/{project-public-id}
Repositories
- Read
List Repositories
List Repositories returns a list of all Repositories and their attributes.
GET /api/v3/repositories - Read
Get Repository
Get Repository returns information about the selected Repository.
GET /api/v3/repositories/{repo-public-id}
Search
- Read
Search
Search lets you search Epics and Stories based on desired parameters. Since ordering of the results can change over time (due to search ranking decay, new Epics and Stories being created), the `next` value from the previous response can be used as the path and query string for the next page to ensure stable ordering.
GET /api/v3/search - Read
Search Documents
Search Documents lets you search Documents based on desired parameters. Supports structured filters: title, archived, created_by_me, followed_by_me.
GET /api/v3/search/documents - Read
Search Epics
Search Epics lets you search Epics based on desired parameters. Since ordering of stories can change over time (due to search ranking decay, new Epics being created), the `next` value from the previous response can be used as the path and query string for the next page to ensure stable ordering.
GET /api/v3/search/epics - Read
Search Iterations
Search Iterations lets you search Iterations based on desired parameters. Since ordering of results can change over time (due to search ranking decay, new Iterations being created), the `next` value from the previous response can be used as the path and query string for the next page to ensure stable ordering.
GET /api/v3/search/iterations - Read
Search Milestones
Search Milestones lets you search Milestones based on desired parameters. Since ordering of results can change over time (due to search ranking decay, new Milestones being created), the `next` value from the previous response can be used as the path and query string for the next page to ensure stable ordering.
GET /api/v3/search/milestones - Read
Search Objectives
Search Objectives lets you search Objectives based on desired parameters. Since ordering of results can change over time (due to search ranking decay, new Objectives being created), the `next` value from the previous response can be used as the path and query string for the next page to ensure stable ordering.
GET /api/v3/search/objectives - Read
Search Stories
Search Stories lets you search Stories based on desired parameters. Since ordering of stories can change over time (due to search ranking decay, new stories being created), the `next` value from the previous response can be used as the path and query string for the next page to ensure stable ordering.
GET /api/v3/search/stories
Stories
- Read
Query Stories
Search Stories lets you search Stories based on desired parameters.
POST /api/v3/stories/search - Read
Get Story
Get Story returns information about a chosen Story.
GET /api/v3/stories/{story-public-id} - Read
List Story Comment
Lists Comments associated with a Story
GET /api/v3/stories/{story-public-id}/comments - Read
Get Story Comment
Get Comment is used to get Comment information.
GET /api/v3/stories/{story-public-id}/comments/{comment-public-id} - Read
Story History
GET /api/v3/stories/{story-public-id}/history
GET /api/v3/stories/{story-public-id}/history - Read
List Story Sub tasks
List Story Sub tasks returns a list of all Sub-task Stories for a given parent Story.
GET /api/v3/stories/{story-public-id}/sub-tasks - Read
Get Task
Returns information about a chosen Task.
GET /api/v3/stories/{story-public-id}/tasks/{task-public-id} - Write
Create Story
Create Story is used to add a new story to your Shortcut Workspace. This endpoint requires that either **workflow_state_id** or **project_id** be provided, but will reject the request if both or neither are specified. The workflow_state_id has been marked as required and is the recommended field to specify because we are in the process of sunsetting Projects in Shortcut.
POST /api/v3/stories - Write
Create Multiple Stories
Create Multiple Stories allows you to create multiple stories in a single request using the same syntax as [Create Story](https://developer.shortcut.com/api/rest/v3#create-story).
POST /api/v3/stories/bulk - Write
Create Story From Template
Create Story From Template is used to add a new story derived from a template to your Shortcut Workspace.
POST /api/v3/stories/from-template - Write
Create Story Comment
Create Comment allows you to create a Comment on any Story.
POST /api/v3/stories/{story-public-id}/comments - Write
Create Story Reaction
Create a reaction to a story comment.
POST /api/v3/stories/{story-public-id}/comments/{comment-public-id}/reactions - Write
Create Task
Create Task is used to create a new task in a Story.
POST /api/v3/stories/{story-public-id}/tasks - Write
Update Task
Update Task can be used to update Task properties.
PUT /api/v3/stories/{story-public-id}/tasks/{task-public-id} - Destructive
Update Multiple Stories
Update Multiple Stories allows you to make changes to numerous stories at once.
PUT /api/v3/stories/bulk - Destructive
Delete Multiple Stories
Delete Multiple Stories allows you to delete multiple archived stories at once.
DELETE /api/v3/stories/bulk - Destructive
Update Story
Update Story can be used to update Story properties.
PUT /api/v3/stories/{story-public-id} - Destructive
Delete Story
Delete Story can be used to delete any Story.
DELETE /api/v3/stories/{story-public-id} - Destructive
Update Story Comment
Update Comment replaces the text of the existing Comment.
PUT /api/v3/stories/{story-public-id}/comments/{comment-public-id} - Destructive
Delete Story Comment
Delete a Comment from any story.
DELETE /api/v3/stories/{story-public-id}/comments/{comment-public-id} - Destructive
Delete Story Reaction
Delete a reaction from any story comment.
DELETE /api/v3/stories/{story-public-id}/comments/{comment-public-id}/reactions - Destructive
Unlink Comment thread from Slack
Unlinks a Comment from its linked Slack thread (Comment replies and Slack replies will no longer be synced)
POST /api/v3/stories/{story-public-id}/comments/{comment-public-id}/unlink-from-slack - Destructive
Delete Task
Delete Task can be used to delete any previously created Task on a Story.
DELETE /api/v3/stories/{story-public-id}/tasks/{task-public-id}
Story links
- Read
Get Story Link
Returns the stories and their relationship for the given Story Link.
GET /api/v3/story-links/{story-link-public-id} - Write
Create Story Link
Story Links (called Story Relationships in the UI) allow you create semantic relationships between two stories. The parameters read like an active voice grammatical sentence: subject -> verb -> object. The subject story acts on the object Story; the object story is the direct object of the sentence. The subject story "blocks", "duplicates", or "relates to" the object story. Examples: - "story 5 blocks story 6” -- story 6 is now "blocked" until story 5 is moved to a Done workflow state. - "story 2 duplicates story 1” -- Story 2 represents the same body of work as Story 1 (and should probably be archived). - "story 7 relates to story 3”
POST /api/v3/story-links - Write
Update Story Link
Updates the stories and/or the relationship for the given Story Link.
PUT /api/v3/story-links/{story-link-public-id} - Destructive
Delete Story Link
Removes the relationship between the stories for the given Story Link.
DELETE /api/v3/story-links/{story-link-public-id}
Workflows
- Read
List Workflows
Returns a list of all Workflows in the Workspace.
GET /api/v3/workflows - Read
Get Workflow
Get Workflow returns information about a chosen Workflow.
GET /api/v3/workflows/{workflow-public-id}
No operations match.
See How connections work for access and permissions, or browse all integrations.